#ifndef DS1621_H
#define DS1621_H
//------------------------------------------------------------------------------
#include "I2C.h"
#include "DS1621_Prototypes.h"
//------------------------------------------------------------------------------
void DS1621_Init(char Addr)
{
  DS1621_Config(Addr);
  DS1621_StartConv(Addr);
}
//----------------------------Setup Device--------------------------------------
void DS1621_Config(char Addr)
{
  I2C_start(); 
    
  I2C_write( Addr + Wr ); 
  I2C_write( CONFIG_REG ); 
  I2C_write( CONT_CONV );       // Continuous conversion,Active high polarity
                           
  I2C_stop();
}
//------------------------Start tempr converstion--------------------------------
void DS1621_StartConv(char Addr)
{
   I2C_start();
    
   I2C_write( Addr + Wr );
   I2C_write( START_CONV );
	
   I2C_stop(); 
}
//------------------------------------------------------------------------------
int DS1621_ReadTemp(char Addr)
{
   char tempHi,tempLo;
   
   I2C_start(); 	           
   	
   I2C_write( Addr + Wr );	    
   I2C_write( TEMP_REG );	    // Access the temperature register
   I2C_restart();	           
   I2C_write( Addr + Rd );	    
   tempHi = I2C_read(ACK);     
   tempLo = I2C_read(NACK);    // Signal End of reception with NACK
	
   I2C_stop();	
   
   return ( (tempHi << 8) + tempLo );
}
//------------------------------------------------------------------------------
float toFloat(signed int tempr)
{
  float result;
 
  if(tempr & FRAC_FLAG)
  {
    result = ((tempr>>8) + 0.5);
  }
  else
      {
        result = ((tempr>>8) + 0.0);   
      }
  
  return result;
}
//------------------------------------------------------------------------------
#endif